=== Tests/RunCMake/include/ParentVariableSubDir/Inc/CMakeLists.txt ===
message(STATUS "ParentVariableSubDir/Inc/CMakeLists\.txt: '${CMAKE_PARENT_LIST_FILE}'")
